package MessageAppl;

import java.util.StringTokenizer;

import org.omg.CORBA.StringHolder;

/**
 * 
 * @author Fosco
 * 
 * Implementazione servant per l'oggetto Message
 */
public class MessageImpl extends MessagePOA
{

  /**
   * Implementazione del servizio di split
   */
  public void split(StringHolder msg, StringHolder inizio, String separatore)
      throws MessageAppl.ErroreApplicativo
  {
    if( separatore.equals("")) throw new ErroreApplicativo("Errore: separatore, deve essere diverso da stringa vuota!!");
    StringTokenizer tok = new StringTokenizer(msg.value, separatore);
    // inizio (out string)
    inizio.value = tok.nextToken();
    // msg (inout string)
    msg.value = tok.nextToken();
  }
}