package MessageAppl;

import java.util.StringTokenizer;

import org.omg.CORBA.StringHolder;
import org.omg.PortableServer.POA;

/**
 * 
 * @author Fosco
 * 
 * Implementazione servant per l'oggetto Message
 */
public class MessageImpl extends MessagePOA
{

  POA myPOA;
  
  public MessageImpl(POA myPOA){ this.myPOA = myPOA; }
  
  /**
   * Implementazione del servizio di split
   */
  public void split(StringHolder msg, StringHolder inizio, String separatore)
      throws MessageAppl.ErroreApplic
  {
    if( separatore.equals("")) throw new ErroreApplic("Errore: separatore, deve essere diverso da stringa vuota!!");
    // DEBUG
    /* 
    System.out.println("Messaggio ricevuto: "+msg.value);
    System.out.println("Separatore ricevuto: "+separatore);
    */
    StringTokenizer tok = new StringTokenizer(msg.value, separatore);
    // inizio (out string)
    inizio.value = tok.nextToken();
    // msg (inout string)
    msg.value = tok.nextToken();
  }
  
  // Overrides default POA
  public POA _default_POA(){ return myPOA; } 
  
}