import org.omg.PortableServer.*;

/**
 * 
 * @author Fosco
 * 
 * Implementazione server
 */
public class server
{

  public static void main(String[] args)
  {
    try
    {
      //Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[])null, null);
      // Creazione oggetto servant
      MessagePOATie servant = new MessagePOATie(new MessageImpl());

      // Ottengo un riferimento al POA 
      POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

      // Registro l'oggetto presso il POA
      org.omg.CORBA.Object obj = rootPOA.servant_to_reference(servant);

      // Attivazione POA -> altrimenti inizialmente il POA e' in stato Holding
      // cioe' richieste accodate, ma non trasmesse all'oggetto
      rootPOA.the_POAManager().activate();

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println(orb.object_to_string(obj));

      // Attivazione del'orb
      orb.run();
    } catch (Exception e)
    {
      System.out.println("Ho ricevuto questa eccezione: "+e);
      e.printStackTrace();
    }
  }
}