import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * 
 * @author Fosco
 * 
 * Implementazione client
 */
public class client
{

  public static void main(String[] args)
  {
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
    
    try
    {
      // Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[]) null, null);

      // Legge lo IOR da standard input
      org.omg.CORBA.Object obj = orb.string_to_object(args[0]);

      // Creazione stub
      Message message_proxy = MessageHelper.narrow(obj);

      // Logica di servizio
      System.out.print("Dammi la stringa di cui vuoi la echo:");
      String inString = input.readLine();
      String result = message_proxy.echo(inString); 
      System.out.println("Ecco il risultato della echo: " + result);
    } catch (Exception e)
    {
      System.out.println("Eccezione, la seguente: " + e);
      e.printStackTrace();
    }

  }
}