package MessageAppl;


import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.omg.CORBA.StringHolder;

/**
 * 
 * @author Fosco
 * 
 * Implementazione client
 */
public class client
{

  public static void main(String[] args)
  {
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    try
    {
      // Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[]) null, null);

      // Legge lo IOR da standard input
      org.omg.CORBA.Object tmp_ref;
      org.omg.CORBA.Object obj_mio;
      // Get the naming context
      tmp_ref = orb.resolve_initial_references("NameService");
      org.omg.CosNaming.NamingContextExt default_context = org.omg.CosNaming.NamingContextExtHelper
          .narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del contesto di default:\n"
          + orb.object_to_string(default_context));

      org.omg.CosNaming.NameComponent [] name = default_context
          .to_name("0000174032");
      System.out
          .println("Sono qui, nome dell'oggetto che sto per registrare, id: "
              + name[0].id + ", kind: " + name[0].kind);
      obj_mio = default_context.resolve(name);
      

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR dell'oggetto cercato:\n"
          + orb.object_to_string(obj_mio));

      // Creazione stub
      Message message_proxy = MessageHelper.narrow(obj_mio);

      // Input/output: messaggio da dividere, poi coda
      StringHolder inString = new StringHolder();
      // Input: separatore
      String sep;
      // Output: testa del messaggio
      StringHolder testa = new StringHolder();

      // Logica di servizio
      System.out
          .print("Dammi la stringa da dividere (nella forma \"testa<SEP>coda\":");
      // aggiungere eventuali controlli sull'input
      inString.value = input.readLine();
      System.out.print("Dammi <SEP>, ad esempio \"|\":");
      sep = input.readLine();
      message_proxy.split(inString, testa, sep);
      System.out.println("Ecco la testa: " + testa.value + ", e la coda: "
          + inString.value);
    } catch (Exception e)
    {
      System.out.println("Eccezione, la seguente: " + e);
      e.printStackTrace();
    }

  }
}